sock = require "sock"
bitser = require "bitser"
ser = require "ser"
require "tools"

if not love.filesystem.getInfo("server_config.txt") then
    config = {
        max_users = 2
    }
    love.filesystem.write("server_config.txt", ser(config))
else
    local file = love.filesystem.load("server_config.txt")
    config = file()
end

math.randomseed(os.time())

reach = 100
sent = 0

function love.load()
    love.window.setMode(256, 128, {resizable=true, x=10, y=40})
    love.window.setTitle("Quârz - Server")

    -- how often an update is sent out
    tickRate = 1/60
    tick = 0

    server = sock.newServer("*", 22122, config.max_users)
    server:setSerialization(bitser.dumps, bitser.loads)

    function newPlayer()
        return {
            position = {
                x = math.random(100, 200),
                y = math.random(100, 200)
            },
            velocity = {
                x = 0,
                y = 0
            },
            health = 4,
            username = "Not found",
            rotation = 0,
            looking = "Not defined"
        }
    end

    players = {}

    server:on("connect", function(data, client)
        local id = math.random(0, 100) .. os.time() .. client:getIndex()
        players[client:getIndex()] = newPlayer()
        client:send("playerNum", {client:getIndex(), players[client:getIndex()].position})
    end)

    server:on("disconnect", function(data, client)
        table.remove(players, client:getIndex())
    end)

    server:on("info", function(data, client)
        players[client:getIndex()].username = data
    end)

    server:on("player", function(data, client)
        players[client:getIndex()].velocity = data.velocity
        players[client:getIndex()].position = data.position
        players[client:getIndex()].angle = data.angle
    end)

    server:on("attack", function(data, client)
        local ang = math.deg(players[client:getIndex()].angle)
        ply = players[client:getIndex()]
        ply.looking = "nowhere"

        if between(ang, -45, 45) then ply.looking = "right"
        elseif between(ang, 45, 135) then ply.looking = "down"
        elseif ang >= 135 or ang <= -135 then ply.looking = "left"
        elseif between(ang, -135, -45) then ply.looking = "up" end

        for k,_ in pairs(players) do
            if slt(players[client:getIndex()].position, players[k].position) <= reach and k ~= client:getIndex() then
                players[k].health = players[k].health - 1
            end
        end
    end)
end

function love.update(dt)
    server:update()

    -- wait until 1 player connect to start playing
    local enoughPlayers = #server.clients >= 1
    if not enoughPlayers then return end

    tick = tick + dt

    if tick >= tickRate then
        tick = 0

        server:sendToAll("playerState", players)
        love.filesystem.write("server_players.lua", ser(players))
        sent = sent + 1
    end
end

function love.draw()
    love.graphics.print("Players: " ..server:getClientCount(), 5, 5)
    love.graphics.print("Data sent: " ..sent, 5, 25)
    for k,_ in pairs(players) do
        local player = players[k].username
        love.graphics.print(tonumber(k).. ". " ..player, 5, tonumber(k) * 20 + 25)
    end
end
